/*$Id: heapsort.c,v 1.1.1.1 2004/04/21 23:21:03 mundacho Exp $*/

#include "heapsort.h"
#include <stdlib.h>
#include <stdio.h>

void heapsort(int *array, int n) /*heap empieza en 0*/
{
	int i;
	/*Construir el heap */
	buildheap(array, 0,n);
	i = n;
	while (i > 0){
		/*Cambiar el primer elemento con el elemento n-1*/
		--i;
		swap(array[0],array[i]);
		/*heapfifycar los n-1 elementos del heap que quedan*/
		heapify(array, 0, i);
	}
	
}
void buildheap(int *array, unsigned int root, unsigned int n)
{
	int hijo_izq, hijo_der, mas_grande;
	hijo_izq = root*2 + 1;
	hijo_der = root*2 + 2;
	mas_grande = root;
	if (hijo_izq >= n) /*si no existe un hijo izquierdo*/
		return;
	buildheap(array,hijo_izq,n); 
	if (hijo_der < n){/*si existe un hijo derecho*/
		buildheap(array,hijo_der,n); 
	}
	heapify(array, root, n);
}
void heapify(int *array, unsigned int root, unsigned int n)
{
	int hijo_izq, hijo_der, mas_grande;
	hijo_izq = root*2 + 1;
	hijo_der = root*2 + 2;
	mas_grande = root;
	if (hijo_izq >= n) /*si no existe un hijo izquierdo*/
		return;
	if (array[mas_grande] < array[hijo_izq])
		mas_grande = hijo_izq;
	if (hijo_der < n){/*si existe un hijo derecho*/
		if (array[mas_grande] < array[hijo_der])
			mas_grande = hijo_der;
	}
	if (mas_grande != root){ /*si la raiz no es el numero ms grande*/
		swap(array[root], array[mas_grande]);/*cambiarla con el*/
		heapify (array, mas_grande, n);
	}
}
