/*$Id*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include <time.h>
#include "heapsort.h"

/***************************************************************************/ 
/*programa para mostrar el algoritmo heapsort con una lista enlazada	   */
/*Autor: mundacho							   */
/*Email: mundacho@bigfoot.com						   */
/*Descripcin: Se le da una entrada de nmeros separados por nuevas lneas */
/*		e imprime la entrada ordenada				   */
/***************************************************************************/ 

int main(void)
{
	int array[MAXELTS], elnum = 0,  valor, i=0;
	clock_t comienzo; /*vamos a medir cuanto tardo en ordenar el archivo*/
	clock_t final;
	struct tms tiempos;
	while (scanf("%d", &valor) != EOF &&
		elnum < MAXELTS){ 
					/*esto lee la entrada hasta el fin*/
					/*del archivo la guarda en array*/
		array[elnum++] = valor;
	}
	if (!elnum)  /*No hubo entrada :'(*/
		return 0;
	comienzo = times (&tiempos); /*los valores almacenados en tiempos no*/
					/*los usaremos*/
	heapsort(array,elnum);
	final = times (&tiempos);
	/*Mostramos la entrada ordenada*/
	/*Imprimimos cuanto tardamos en ordenar la entrada*/
	while (i < elnum)
		printf("%d\n", array[i++] );
	printf ("Se tardaron %f segundos en ordenar el archivo\n", (float) (final - comienzo) / CLOCKS_PER_SEC);
return 0;
}
